{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": "grep",
            "stdout": "results.txt",
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-e"
                    },
                    "label": "allows for use of regex in search_string",
                    "id": "#grep.cwl/extended"
                },
                {
                    "type": "File",
                    "streamable": true,
                    "inputBinding": {
                        "position": 3
                    },
                    "label": "the file to look occurences of the search_string for.",
                    "id": "#grep.cwl/search_file"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2
                    },
                    "label": "the string or expression to search for",
                    "id": "#grep.cwl/search_string"
                }
            ],
            "id": "#grep.cwl",
            "outputs": [
                {
                    "type": "File",
                    "label": "all the occurences of the search_string in the search_file.",
                    "id": "#grep.cwl/occurences",
                    "outputBinding": {
                        "glob": "results.txt"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "tar",
            "arguments": [
                "-x",
                "-z",
                "-v",
                "-f"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#tar.cwl/compress_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*"
                    },
                    "id": "#tar.cwl/uncompress_file"
                }
            ],
            "id": "#tar.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "wc",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "stdout": "$(inputs.output_filename)",
            "arguments": [
                "-l"
            ],
            "inputs": [
                {
                    "type": "File",
                    "streamable": true,
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#wc.cwl/input_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "count.txt",
                    "id": "#wc.cwl/output_filename"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#wc.cwl/count",
                    "outputBinding": {
                        "glob": "$(inputs.output_filename)"
                    }
                }
            ],
            "id": "#wc.cwl"
        },
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/output_filename"
                },
                {
                    "type": "string",
                    "id": "#main/search_string"
                },
                {
                    "type": "File",
                    "id": "#main/zip_file"
                }
            ],
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "steps": [
                {
                    "run": "#grep.cwl",
                    "in": [
                        {
                            "default": true,
                            "id": "#main/grep/extended"
                        },
                        {
                            "source": "#main/untar/uncompress_file",
                            "id": "#main/grep/search_file"
                        },
                        {
                            "source": "#main/search_string",
                            "id": "#main/grep/search_string"
                        }
                    ],
                    "out": [
                        "#main/grep/occurences"
                    ],
                    "id": "#main/grep"
                },
                {
                    "run": "#tar.cwl",
                    "in": [
                        {
                            "source": "#main/zip_file",
                            "id": "#main/untar/compress_file"
                        }
                    ],
                    "out": [
                        "#main/untar/uncompress_file"
                    ],
                    "id": "#main/untar"
                },
                {
                    "run": "#wc.cwl",
                    "in": [
                        {
                            "source": "#main/grep/occurences",
                            "id": "#main/wc/input_file"
                        },
                        {
                            "source": "#main/output_filename",
                            "id": "#main/wc/output_filename"
                        }
                    ],
                    "out": [
                        "#main/wc/count"
                    ],
                    "id": "#main/wc"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/wc/count",
                    "id": "#main/occurences"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
